'Wed  Jul 26, 1989   10:51:31 am
'                       
'*****************************************************************************
'READHELP is an utility to accompany the MAKEHELP help screen file maker.
'*****************************************************************************

DECLARE SUB splitline (inline$)
DECLARE FUNCTION exists! (filename$)
DECLARE SUB filebusiness ()
DECLARE SUB getkey ()
DECLARE SUB header ()
DECLARE SUB helpscreen ()
DECLARE SUB goodbye ()

TYPE regtype
     ax    AS INTEGER
     bx    AS INTEGER
     cx    AS INTEGER
     dx    AS INTEGER
     bp    AS INTEGER
     si    AS INTEGER
     di    AS INTEGER
     flags AS INTEGER
END TYPE

TYPE record
        lines AS STRING * 80
END TYPE

DIM SHARED inregs AS regtype, outregs AS regtype, text AS record, arg$(5)

COMMON SHARED infile$, infile, lines, in$, esc$, length

esc$ = CHR$(27)
pgup$ = CHR$(0) + CHR$(73)
'************************* MAIN PROGRAM BEGINS HERE *************************
     CLS
     filebusiness
     header
     start = TIMER
     WHILE NOT EOF(infile)
          page = page + 1
          LOCATE 1, 17: PRINT page;
          LOCATE 2, 1
          FOR x = 1 TO length
                COLOR 7, 0
                lines = lines + 1
                GET infile, lines, text
                PRINT text.lines;
                COLOR 0, 7
          NEXT x
          LOCATE 1, 28: PRINT lines
          getkey
          IF in$ = esc$ THEN goodbye
          IF in$ = pgup$ THEN
                lines = lines - (2 * length)
                IF lines < 0 THEN lines = 0
                page = page - 2
                IF page < 1 THEN page = 0
          END IF
     WEND
     goodbye
'************************* MAIN PROGRAM ENDS HERE ***************************

FUNCTION exists (filename$)
     f$ = filename$ + CHR$(0)
     inregs.ax = &H1100: inregs.dx = SADD(f$)
     CALL interrupt(&H21, inregs, outregs)
     handle = outregs.ax
    
     inregs.bx = handle
     inregs.ax = &H4E00
     CALL interrupt(&H21, inregs, outregs)
     f = outregs.ax
     IF f = 0 THEN f = 1 ELSE f = 0
     exists = f
END FUNCTION

SUB filebusiness
        inline$ = COMMAND$
        IF inline$ = "" THEN helpscreen
        splitline inline$
        infile$ = arg$(1)
        length = VAL(arg$(2))
        IF length = 0 THEN
                PRINT "ERROR: Need valid page length."
                helpscreen
        END IF
        IF exists(infile$) = no THEN
                 PRINT "ERROR: No file by that name found."
                 helpscreen
        END IF
        infile = FREEFILE
        OPEN infile$ FOR RANDOM AS infile LEN = 80
END SUB

SUB getkey
i:  in$ = INKEY$: IF in$ = "" THEN GOTO i
END SUB

SUB goodbye
     LOCATE 24, 1
     CLOSE
     END
END SUB

SUB header
     COLOR 0, 7
     PRINT STRING$(80, 32);
     LOCATE 1, 1: COLOR 15, 7: PRINT "READHELP "; : COLOR 0, 7: PRINT "Screen:      Line:"
     LOCATE 1, 36: PRINT "[PgUp] PREVIOUS   [Others] NEXT   [Esc] EXIT"
END SUB

SUB helpscreen
     PRINT ""
     PRINT "READHELP is an utility to read random access help screen files"
     PRINT "made by the MAKEHELP program. (c) 1989 David Wesson"
     PRINT " "
     PRINT "Syntax: READHELP  [d:]helpfile.ext  pagelength"
     PRINT " where  helpfile.ext =  full helpfile name  [drive optional] "
     PRINT "        pagelength   =  number of lines per page (between 1 and 23"
     PRINT ""
     PRINT "NOTE: The program reads a random file of record length 80."
     END
END SUB

SUB splitline (inline$)
     num = 1
     FOR x = 1 TO LEN(inline$)
          ch$ = MID$(inline$, x, 1)
          IF ch$ <> " " THEN
               arg$(num) = arg$(num) + ch$
               ELSE num = num + 1
          END IF
     NEXT x
END SUB

